
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>

typedef long long llong;
const int MAXN = 100000 + 10;
const int INF  = 1e9;

int n;
int a[MAXN];
int b[MAXN];
int sorted[MAXN];
int treeLeft[MAXN];
int treeRight[MAXN];
int removeAt[MAXN];
int removed[MAXN];

void update(int tree[], int pos, int value)
{
	if (pos == 0) return;
	for (int idx = pos ; idx <= n ; idx += idx & (-idx))
	{
		tree[idx] += value;
	}
}

int query(int tree[], int pos)
{
	int ans = 0;
	for (int idx = pos ; idx >= 1 ; idx -= idx & (-idx))
	{
		ans += tree[idx];
	}

	return ans;
}

llong invCnt = 0;
void divide(int l, int r)
{
	if (l == r)
	{
		return;
	}

	int mid = (l + r) / 2;
	divide(l, mid); divide(mid + 1, r);

	for (int i = l ; i <= mid ; ++i)
	{
		update(treeLeft, removeAt[a[i]], 1);
	}

	int pos = l;
	int lPtr = l, rPtr = mid + 1;
	while (lPtr <= mid || rPtr <= r)
	{
		if (lPtr == mid + 1)
		{
			removed[a[rPtr]] += query(treeLeft, removeAt[a[rPtr]]);
			update(treeRight, removeAt[a[rPtr]], 1);
			sorted[pos++] = a[rPtr];
			rPtr++;
			continue;
		}

		if (rPtr == r + 1)
		{
			removed[a[lPtr]] += query(treeRight, removeAt[a[lPtr]]);
			update(treeLeft, removeAt[a[lPtr]], -1);
			invCnt += rPtr - mid - 1;
			sorted[pos++] = a[lPtr];
			lPtr++;
			continue;
		}

		if (a[lPtr] < a[rPtr])
		{
			removed[a[lPtr]] += query(treeRight, removeAt[a[lPtr]]);
			update(treeLeft, removeAt[a[lPtr]], -1);
			sorted[pos++] = a[lPtr];
			invCnt += rPtr - mid - 1;
			lPtr++;
			continue;
		} else
		{
			removed[a[rPtr]] += query(treeLeft, removeAt[a[rPtr]]);
			update(treeRight, removeAt[a[rPtr]], 1);
			sorted[pos++] = a[rPtr];
			rPtr++;
			continue;
		}
	}

	for (int i = mid + 1 ; i <= r ; ++i)
	{
		update(treeRight, removeAt[a[i]], -1);
	}

	for (int i = l ; i <= r ; ++i)
	{
		a[i] = sorted[i];
	}
}

void solve()
{
	divide(1, n);
	std::cout << invCnt;
	for (int i = 1 ; i <= n - 2 ; ++i)
	{
		invCnt -= removed[b[i]];
		std::cout << ' ' << invCnt;
	}

	std::cout << '\n';
}

void read()
{
	std::cin >> n;
	for (int i = 1 ; i <= n ; ++i)
	{
		std::cin >> a[i];
	}

	std::fill(removeAt + 1, removeAt + 1 + n, 1);
	for (int i = 1 ; i <= n - 2 ; ++i)
	{
		std::cin >> b[i];
		removeAt[b[i]] = n - i;
	}
}

void fastIO()
{
	std::ios_base :: sync_with_stdio(0);
	std::cout.tie(nullptr);
	std::cin.tie(nullptr);
}

int main()
{
	// fastIO();
	read();
	solve();

	return 0;
}