#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 1e5 + 10;

struct fenwick
{
    int fen[maxn];

    int get(int v)
    {
        int s = 0;
        for (int i = v; i > 0; i -= i & (- i))
        {
            s += fen[i];
        }
        return s;
    }

    void update(int v, int s)
    {
        for (int i = v; i < maxn; i += (i & (-i)))
            fen[i] += s;
    }

    int sum(int left, int right)
    {
        return get(right) - get(left - 1);
    }

};

fenwick f1, f2;

int n, a[maxn], t[maxn];
ll to_rem[maxn];
ll inv;
void conquer(int left, int mid, int right)
{
    int lf = left, rf = mid + 1;
    vector < int > vec;
    for (int i = left; i <= mid; i ++)
        f2.update(t[a[i]], 1);
    while(lf <= mid && rf <= right)
    {
        if (a[lf] < a[rf])
        {
            vec.push_back(a[lf]);
            inv = inv + rf - mid - 1;
            to_rem[a[lf]] += f1.sum(t[a[lf]], maxn - 1);
            f2.update(t[a[lf]], -1);
            ///cout << a[lf] << " : " << to_rem[a[lf]] << " " << left << " " << right << endl;
            lf ++;
        }
        else
        {
            vec.push_back(a[rf]);
            to_rem[a[rf]] += f2.sum(t[a[rf]], maxn - 1);
            f1.update(t[a[rf]], 1);
            rf ++;
        }
    }

    while(lf <= mid)
    {
        vec.push_back(a[lf]);
        to_rem[a[lf]] += f1.sum(t[a[lf]], maxn - 1);
        f2.update(t[a[lf]], -1);
        inv = inv + rf - mid - 1;
        lf ++;
    }

    while(rf <= right)
    {
        vec.push_back(a[rf]);
        f1.update(t[a[rf]], 1);
        rf ++;
    }

    for (int i = mid + 1; i <= right; i ++)
        f1.update(t[a[i]], -1);
    for (int i = 0; i < vec.size(); i ++)
        a[i + left] = vec[i];
}

void divide(int left, int right)
{
    if (left == right)
        return;

    int mid = (left + right) / 2;
    divide(left, mid);
    divide(mid + 1, right);

    conquer(left, mid, right);
}

int ord[maxn], st[maxn];
void solve()
{
    cin >> n;
    for (int i = 1; i <= n; i ++)
    {
        cin >> a[i];
        st[a[i]] = i;
    }

    for (int i = 1; i < n - 1; i ++)
    {
        ///int x;
        cin >> ord[i];
        t[ord[i]] = i;
    }

    for (int i = 1; i <= n; i ++)
        if (t[i] == 0)
            t[i] = n;

    divide(1, n);

    cout << inv << " ";
    for (int i = 1; i < n - 1; i ++)
    {
        inv -= to_rem[ord[i]];
        cout << inv << " ";
    }
    cout << endl;
}

int main()
{
    solve();
    return 0;
}
/**
6
6 1 2 5 3 4
3 5 4 6
*/
