#include <iostream>
#define endl '\n'
using namespace std;

const int MAXN = 100000;

int n, t;
long long sum;
int q[MAXN + 5];
int rmv[MAXN + 5];
int priority[MAXN + 5];
int a[MAXN + 5], b[MAXN + 5];
int fw[MAXN + 5], used[MAXN + 5];

void update(int idx, int val)
{
    while (idx <= n)
    {
        if (used[idx] < t) fw[idx] = 0;
        used[idx] = t;
        fw[idx] += val;
        idx += (idx & (-idx));
    }
}

int query(int idx)
{
    int ret = 0;
    while (idx)
    {
        if (used[idx] < t) fw[idx] = 0;
        used[idx] = t;
        ret += fw[idx];
        idx -= (idx & (-idx));
    }
    return ret;
}

void Merge(int l, int mid, int r)
{
    int PtrL = l, PtrR = mid + 1, Ptr = l;
    t++;
    while (PtrL <= mid or PtrR <= r)
    {
        if (PtrL > mid or (PtrR <= r and a[PtrR] > a[PtrL]))
        {
            rmv[a[PtrR]] += query(priority[a[PtrR]]);
            sum += PtrL - l;
            b[Ptr++] = a[PtrR];
            PtrR++;
        }
        else
        {
            update(priority[a[PtrL]], 1);
            b[Ptr++] = a[PtrL];
            PtrL++;
        }
    }

    PtrL = mid; PtrR = r;
    t++;
    while (PtrL >= l or PtrR >= mid + 1)
    {
        if (PtrL < l or (PtrR >= mid + 1 and a[PtrR] < a[PtrL]))
        {
            update(priority[a[PtrR]], 1);
            PtrR--;
        }
        else
        {
            rmv[a[PtrL]] += query(priority[a[PtrL]]);
            PtrL--;
        }
    }

    for (int i = l; i <= r; ++ i)
    {
        a[i] = b[i];
    }
}

void MergeSort(int l, int r)
{
    if (l == r) return;
    int mid = (l + r) / 2;
    MergeSort(l, mid);
    MergeSort(mid + 1, r);
    Merge(l, mid, r);
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        priority[i] = 1;
    }

    for (int i = 1; i <= n - 2; ++ i)
    {
        cin >> q[i];
        priority[q[i]] = n - i;
    }

    MergeSort(1, n);

    cout << sum << " ";
    for (int i = 1; i <= n - 2; ++ i)
    {
        sum -= rmv[q[i]];
        cout << sum << " ";
    }
    cout << endl;

    return 0;
}
