#include <bits/stdc++.h>
using namespace std;
const int N = 1e5 + 10, S = 333;
int n, vis[N], low[N], up[N], pos[N];
vector<int> a;
long long ans = 0;

#define dbg(x) cout << #x << " " << x << endl;
#define sz(x) (int)x.size()

struct fenwick {
  int size;
  vector<int> tree;

  void init(int s) {
    size = s + 2;
    tree.assign(size + 2, 0);
  }

  void upd(int u) {
    while(u < size) {
      tree[u]++;
      u += u & (-u);
    }
  }

  int qry(int u) {
    int answ = 0;
    while(u > 0) {
      answ += tree[u];
      u -= u & (-u);
    }
    return answ;
  }

  int sum(int l, int r) {
    if(l > r) return 0;
    return qry(r) - qry(l - 1);
  }
} ft;

void calc(vector<int>& to_delete) {
  ft.init(n + 1);
  for(auto i: to_delete) {
    vis[i] = true;
  }

  ans = 0;
  vector<int> new_a;
  for(auto i: a) {
    if(!vis[i]) {
      new_a.push_back(i);
      low[i] = ft.sum(i + 1, n);
      ans += low[i];
      ft.upd(i);
    }
  }

  a.swap(new_a);
  ft.init(n + 1);
  for(int i = sz(new_a) - 1; i >= 0; i--) {
    up[new_a[i]] = ft.sum(1, new_a[i] - 1);
    ft.upd(new_a[i]);
  }
}

int main() {
  cin >> n;
  a.resize(n);
  for(int i = 0; i < n; i++) {
    cin >> a[i], pos[a[i]] = i;
  }

  vector<int> to_delete;
  calc(to_delete);

  cout << ans << " ";
  for(int i = 0; i < n - 2; i++) {
    int q; cin >> q;

    ans -= (low[q] + up[q]);

    for(auto j: to_delete) {
      if(pos[q] > pos[j] && q < j) {
        ans++;
      }
      if(pos[q] < pos[j] && q > j) {
        ans++;
      }
    }

    cout << ans << " ";
    to_delete.push_back(q);
    if(sz(to_delete) == S) {
      calc(to_delete);
      to_delete.clear();
    }
  }
  cout << '\n';

  return 0;
}