#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,fma,avx2")

#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <random>


using namespace std;


#define ll long long


const int blck_sz = 3000;
const int maxn = 1e5;

int m;
vector<vector<int>> blcks;
int d[maxn];

void build(int n) {
    m = (n + blck_sz - 1) / blck_sz;
    blcks.assign(m, {});
    for (int i = 0; i < n; i += 1) {
        d[i] = -1;
    }
}


void chng(int i, int x) {
    d[i] = x;
    int b = i / blck_sz;
    for (auto it = blcks[b].begin(); ; ++it) {
        if (it == blcks[b].end() || *it > x) {
            blcks[b].insert(it, x);
            break;
        }
    }
}


ll get_bgr(int i, int x, int n) {
    int b = i / blck_sz;
    int rs = 0;
    for (int j = 0; j < b; j += 1) {
        rs += blcks[j].end() - upper_bound(blcks[j].begin(), blcks[j].end(), x);
    }
    for (int j = b * blck_sz; j < i; j += 1) {
        if (d[j] > x) {
            rs += 1;
        }
    }
    for (int j = i + 1; j < n && j < (b + 1) * blck_sz; j += 1) {
        if (d[j] != -1 && d[j] < x) {
            rs += 1;
        }
    }
    for (int j = b + 1; j < m; j += 1) {
        rs += upper_bound(blcks[j].begin(), blcks[j].end(), x) - blcks[j].begin();
    }
    return rs;
}


int n;
vector<int> p;
vector<int> ps;
vector<int> a;
vector<int> usd;


int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    p.resize(n);
    ps.resize(n);
    for (int i = 0; i < n; i += 1) {
        cin >> p[i];
        --p[i];
        ps[p[i]] = i;
    }
    usd.assign(n, 0);
    a.resize(n - 2);
    for (int i = 0; i < n - 2; i += 1) {
        cin >> a[i];
        --a[i];
        usd[a[i]] = 1;
    }
    build(n);
    vector<ll> ans;
    ans.reserve(n - 1);
    ll rs = 0;
    for (int x = 0; x < n; x += 1) {
        if (!usd[x]) {
            int i = ps[x];
            rs += get_bgr(i, x, n);
            chng(i, x);
        }
    }
    ans.push_back(rs);
    for (int t = n - 3; t >= 0; t -= 1) {
        int x = a[t];
        int i = ps[x];
        rs += get_bgr(i, x, n);
        chng(i, x);
        ans.push_back(rs);
    }
    reverse(ans.begin(), ans.end());
    for (auto t : ans) {
        cout << t << " ";
    }
    cout << "\n";
    return 0;
}