#pragma GCC optimize("O3")
#pragma GCC target("avx512f,avx512dq")
#include <bits/stdc++.h>

int64_t count_inv(std::vector<int> input) {
    int n = input.size();
    struct BIT {
        int n;
        std::vector<int> data;

        BIT(int n = 0) {
            this->n = n;
            data.assign(n, 0);
        }

        void update(int i, int dlt) {
            for (; i < n; i |= i + 1) {
                data[i] += dlt;
            }
        }

        int get(int i) {
            int res = 0;
            for (; i >= 0; i = (i & (i + 1)) - 1) {
                res += data[i];
            }
            return res;
        }
    };

    BIT bt(n);
    int64_t res = 0;
    for (int i = 0; i < n; i++) {
        res += i - bt.get(input[i]);
        bt.update(input[i], 1);
    }
    return res;
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int n;
    std::cin >> n;
    std::vector<int> input(n);
    for (int& i : input) {
        std::cin >> i;
        i--;
    }
    std::vector<int> pos(n);
    for (int i = 0; i < n; i++) {
        pos[input[i]] = i;
    }
    std::vector<int> quer(n - 2);
    for (int& i : quer) {
        std::cin >> i;
        i--;
    }

    int64_t inv = 0;
    // for (int i = 0; i < n; i++) {
    //     int dlt = 0;

    //     for (int j = 0; j < i; j++) {
    //         dlt += input[i] < input[j];
    //     }
    //     inv += dlt;
    // }

    inv = count_inv(input);

    std::cout << inv << " ";
    for (int i = 0; i < n - 2; i++) {
        int dlt = 0;
        int q = quer[i];
        int p = pos[q];

        for (int i = 0; i < p; i++) {
            dlt += input[i] != -1 && input[i] > q;
        }
        for (int i = p + 1; i < n; i++) {
            dlt += input[i] != -1 && input[i] < q;
        }
        input[p] = -1;
        inv -= dlt;
        std::cout << inv << " \n"[i == n - 3];
    }

    return 0;
}
