// #pragma GCC optimize("O3")
#pragma GCC target("avx512f,bmi,bmi2,lzcnt")
#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>

struct BIT {
    int n;
    std::vector<int> data;

    BIT(int n = 0, bool fill = false) {
        this->n = n;
        data.assign(n, 0);
        if (fill) {
            for (int i = 0; i < n; i++) {
                data[i] = i - ((i & (i + 1)) - 1);
            }
        }
    }

    void update(int i, int dlt) {
        for (; i < n; i |= i + 1) {
            data[i] += dlt;
        }
    }

    int get(int i) {
        int res = 0;
        for (; i >= 0; i = (i & (i + 1)) - 1) {
            res += data[i];
        }
        return res;
    }
};

template <typename T>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type, std::less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

struct FUCK {
    int n;
    std::vector<ordered_set<std::pair<int, int>>> vec;

    FUCK(int n = 0) : n(n), vec(n) {
        ;
    }

    void insert(int i, int val) {
        int p = i;
        for (; i < n; i |= i + 1) {
            vec[i].insert({val, p});
        }
    }

    void erase(int i, int val) {
        int p = i;
        for (; i < n; i |= i + 1) {
            vec[i].erase({val, p});
        }
    }

    inline int get_le(const ordered_set<std::pair<int, int>>& set, int val) {
        int res = set.order_of_key({val + 1, -1});
        return res;
    }

    int get_le(int i, int val) {
        int res = 0;
        for (; i >= 0; i = ((i + 1) & i) - 1) {
            res += get_le(vec[i], val);
        }
        return res;
    }

    inline int get_gt(const ordered_set<std::pair<int, int>>& set, int val) {
        int res = set.order_of_key({val + 1, -1});
        res = set.size() - res;
        return res;
    }

    int get_gt(int i, int val) {
        int res = 0;
        for (; i >= 0; i = ((i + 1) & i) - 1) {
            res += get_gt(vec[i], val);
        }
        return res;
    }
};

struct SHIT {
    std::vector<std::vector<int>> data;
    std::vector<BIT> bit;
    int size;

    SHIT(std::vector<int> input) {
        int n = input.size();
        size = 1 << 32 - __builtin_clz(std::max(1, n - 1));
        data.assign(size * 2, {});
        bit.assign(size * 2, BIT());

        for (int i = 0; i < n; i++) {
            data[size + i] = {input[i]};
        }
        for (int i = size - 1; i > 0; i--) {
            data[i].resize(data[2 * i].size() + data[2 * i + 1].size());
            std::merge(data[2 * i + 1].begin(), data[2 * i + 1].end(), data[2 * i].begin(), data[2 * i].end(), data[i].begin());
        }

        for (int i = 0; i < 2 * size; i++) {
            bit[i] = BIT(data[i].size(), true);
        }
    }

    int lb(int i, int val) {
        int it = std::lower_bound(data[i].begin(), data[i].end(), val) - data[i].begin();
        return it;
    }

    void update(int i, int val, int dlt) {
        i += size;
        for (; i > 0; i >>= 1) {
            bit[i].update(lb(i, val), dlt);
        }
    }

    int get_le(int i, int val) {
        int res = bit[i].get(lb(i, val + 1) - 1);
        return res;
    }

    int get_le(int l, int r, int val) {
        int res = 0;
        for (l += size, r += size; l < r; l >>= 1, r >>= 1) {
            if (l & 1) {
                res += get_le(l++, val);
            }
            if (r & 1) {
                res += get_le(--r, val);
            }
        }
        return res;
    }
};

int64_t count_inv(std::vector<int> input) {
    int n = input.size();

    BIT bt(n);
    int64_t res = 0;
    for (int i = 0; i < n; i++) {
        res += i - bt.get(input[i]);
        bt.update(input[i], 1);
    }
    return res;
}

std::mt19937 rnd;

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

#ifdef LOCAL
#define CUM
#endif

    int n;
    n = 1e5;
#ifndef CUM
    std::cin >> n;
#endif
    std::vector<int> input(n);
#ifdef CUM
    std::iota(input.begin(), input.end(), 0);
    std::shuffle(input.begin(), input.end(), rnd);
#endif
    for (int& i : input) {
#ifndef CUM
        std::cin >> i;
        i--;
#endif
    }
    std::vector<int> pos(n);
    for (int i = 0; i < n; i++) {
        pos[input[i]] = i;
    }
    std::vector<int> quer(n - 2);
#ifdef CUM
    std::iota(quer.begin(), quer.end(), 0);
    std::shuffle(quer.begin(), quer.end(), rnd);
#endif
    for (int& i : quer) {
#ifndef CUM
        std::cin >> i;
        i--;
#endif
    }

    int64_t inv = 0;
    inv = count_inv(input);

    BIT bt(n);
    SHIT shit(input);
    for (int i = 0; i < n; i++) {
        // shit.update(i, input[i], 1);
        bt.update(i, 1);
    }

    std::cout << inv << " ";
    for (int i = 0; i < n - 2; i++) {
        int dlt = 0;
        int q = quer[i];
        int p = pos[q];

        shit.update(p, q, -1);
        bt.update(p, -1);

        dlt += bt.get(p) - shit.get_le(0, p, q);
        dlt += shit.get_le(p + 1, shit.size, q);

        inv -= dlt;
        std::cout << inv << " \n"[i == n - 3];
    }

    return 0;
}
