#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <time.h>
using namespace std;

struct node {
	int x;
	int y;
	int sz = 1;
	node* l = 0, * r = 0;
	node(int x) {
		this->x = x;
		this->y = rand();
	}
};
int gs(node* root) {
	if (!root)
		return 0;
	return root->sz;
}
void upd(node* root) {
	if (!root)
		return;
	root->sz = 1 + gs(root->l) + gs(root->r);
}
node* merge(node* l,node*r) {
	if (!l) {
		return r;
	}
	if (!r)
		return l;
	if (l->y > r->y) {
		l->r = merge(l->r, r);
		upd(l);
		return l;
	}
	else {
		r->l = merge(l, r->l);
		upd(r);
		return r;
	}
}
pair<node*,node*> split(node* root, int k) {
	if (!root) {
		return { 0,0 };
	}
	if (root->x > k) {
		auto t = split(root->l, k);
		root->l = t.second;
		upd(root);
		return { t.first,root };
	}
	else {
		auto t = split(root->r, k);
		root->r = t.first;
		upd(root);
		return { root,t.second };
	}
}
void insert(node* &root, int val) {
	node* nn = new node(val);
	auto t = split(root, val);
	root=merge(merge(t.first, nn), t.second);
}
void erase(node*& root, int val) {
	auto t = split(root, val - 1);
	auto tt = split(t.second, val);
	delete tt.first;
	root = merge(t.first, tt.second);
}
int getleq(node* &root, int val) {
	auto t = split(root, val);
	int ans = gs(t.first);
	root=merge(t.first, t.second);
	return ans;
}
int getmeq(node*& root, int val) {
	auto t = split(root, val-1);
	int ans = gs(t.second);
	root = merge(t.first, t.second);
	return ans;
}



vector<set<int> > d;
void rem(int v, int l, int r, int pos,int val) {
	if (l>pos||r<pos) {
		return;
	}
	d[v].insert(val);
	if (l == r) {
		return;
	}
	rem(2 * v + 1, l, (l + r) / 2, pos, val);
	rem(2 * v + 2, (l + r) / 2 + 1, r, pos, val);
}
void add(int v, int l, int r, int pos, int val) {
	if (l > pos || r < pos) {
		return;
	}
	d[v].erase(val);
	if (l == r) {
		return;
	}
	add(2 * v + 1, l, (l + r) / 2, pos, val);
	add(2 * v + 2, (l + r) / 2 + 1, r, pos, val);
}
int askleq(int v, int l,int r, int askl, int askr, int val) {
	if (l > askr || r < askl) {
		return 0;
	}
	if (l >= askl && r <= askr) {
		d[v].lower_bound(val);
		return 0;
	}
	int aa = askleq(2 * v + 1, l, (l + r) / 2, askl, askr, val);
	int bb = askleq(2 * v + 2, (l + r) / 2 + 1, r, askl, askr, val);
	return aa + bb;
}
int askmeq(int v, int l, int r, int askl, int askr, int val) {
	if (l > askr || r < askl) {
		return 0;
	}
	if (l >= askl && r <= askr) {
		d[v].lower_bound(val);
		return 0;
	}
	int aa = askmeq(2 * v + 1, l, (l + r) / 2, askl, askr, val);
	int bb = askmeq(2 * v + 2, (l + r) / 2 + 1, r, askl, askr, val);
	return aa + bb;
}


int main() {
	srand(time(NULL));
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	int n;
	cin >> n;
	d.resize(4 * n);
	map<int, int> mp;
	vector<int> anses;
	int total = 0;
	for (int i = 0; i < n; i++) {
		int x;
		cin >> x;
		add(0, 0, n - 1, i, x);
		/*if (i > 0) {
			total += askmeq(0, 0, n - 1, 0, i - 1, x);
		}
		if (i < n - 1) {
			total += askleq(0, 0, n - 1, i+1, n-1, x);
		}*/
		mp[x] = i;
	}
	anses.push_back(total);
	for (int i = 0; i < n - 2; i++) {
		int x;
		cin >> x;
		int pos = mp[x];
		rem(0, 0, n - 1, pos, x);
		total -= askmeq(0, 0, n - 1, 0, pos - 1, x);
		total -= askleq(0, 0, n - 1, pos + 1, n - 1, x);
		anses.push_back(total);
	}
	for (auto h : anses) {
		cout << h << ' ';
	}

}
