#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define ll long long
#define ld long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;
using namespace __gnu_pbds;
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

struct SegTree{
    int sz;
    vector<oset<int>> tree;

    SegTree(int n){
        sz = 1;
        while (sz < 2 * n){
            sz *= 2;
        }
        tree.resize(sz);
    }

    void upd1(int v, int x){
        v += sz / 2;
        while (v){
            tree[v].insert(x);
            v /= 2;
        }
    }

    void upd2(int v, int x){
        v += sz / 2;
        while (v){
            tree[v].erase(x);
            v /= 2;
        }
    }

    int get_cnt(int v, int x, int l, int r, int tl, int tr){
        if (tl > r || l > tr){
            return 0;
        }
        if (l <= tl && tr <= r){
            return tree[v].order_of_key(x);
        }
        int tm = (tl + tr) / 2;
        return get_cnt(v * 2, x, l, r, tl, tm) + 
               get_cnt(v * 2 + 1, x, l, r, tm + 1, tr);
    }

    int get_cnt(int l, int r, int x){
        return get_cnt(1, x, l, r, 0, sz / 2 - 1);
    }

    int get_len(int v, int l, int r, int tl, int tr){
        if (tl > r || l > tr){
            return 0;
        }
        if (l <= tl && tr <= r){
            return tree[v].size();
        }
        int tm = (tl + tr) / 2;
        return get_len(v * 2, l, r, tl, tm) +  
               get_len(v * 2 + 1, l, r, tm + 1, tr);
    }

    int get_len(int l, int r){
        return get_len(1, l, r, 0, sz / 2 - 1);
    }
};

struct BIT{
    int sz;
    vector<oset<int>> t;

    BIT(int n){
        t.resize(n + 10);
        sz = n + 10;
    }

    void upd1(int v, int x){
        for (int i = v; i < sz; i += i & -i){
            t[i].insert(x);
        }
    }

    void upd2(int v, int x){
        for (int i = v; i < sz; i += i & -i){
            t[i].erase(x);
        }
    }

    int get_cnt(int r, int x){
        int res = 0;
        for (; r; r -= r & -r){
            res += t[r].order_of_key(x);
        }
        return res;
    }

    int get_cnt(int l, int r, int x){
        return get_cnt(r, x) - get_cnt(l - 1, x);
    }

    int get_len(int r){
        int res = 0;
        for (; r; r -= r & -r){
            res += t[r].size();
        }
        return res;
    }

    int get_len(int l, int r){
        return get_len(r) - get_len(l - 1);
    }
};

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef ON_PC
        freopen("input.txt", "r", stdin);
    #endif
    // freopen("output.txt", "w", stdout);
    int T = 1;
    // cin >> T;
    while (T--){
        int n;
        cin >> n;
        vector<int> a(n + 1);
        vector<int> pos(n + 1);
        for (int i = 1; i <= n; i++){
            cin >> a[i];
            pos[a[i]] = i;
        }
        BIT st(n + 1);
        for (int i = 1; i <= n; i++){
            st.upd1(i, a[i]);
        }
        ll cur = 0;
        for (int i = 2; i <= n; i++){
            cur += st.get_len(1, i - 1) - st.get_cnt(1, i - 1, a[i]);
        }
        cout << cur << " ";
        for (int id = 0; id < n - 2; id++){
            int x;
            cin >> x;
            if (pos[x] > 1){
               int i = pos[x];
               cur -= st.get_len(1, i - 1) - st.get_cnt(1, i - 1, x);
            }
            if (pos[x] + 1 <= n){
                int i = pos[x];
                cur -= st.get_cnt(i + 1, n, x);
            }
            st.upd2(pos[x], x);
            cout << cur << " ";
        }
    }
}