#include <bits/stdc++.h>

#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define pb push_back
//#define int long long

using namespace std;

typedef long long ll;

const ll inf = 1e18;
const int MAX = 1e5;

int n;

struct fenwick {
    vector<short> f;

    fenwick() {
        f.resize(MAX + 5);
    };

    void update(int p, int x) {
        p += 3;
        for(; p < f.size(); p += p & -p) {
            f[p] += x;
        }
    };

    int get(int p) {
        p += 3;
        int ans = 0;
        for(; p; p -= p & -p) {
            ans += f[p];
        }
        return ans;
    };

    int get(int l, int r) {
        if(r < 0) {
            return 0;
        }
        int ans = get(r) - (l? get(l - 1) : 0);
        return ans;
    }
};

const int buben = 300;

void solve() {
    cin >> n;
    vector<int> a(n);
    for(auto &i : a) {
        cin >> i;
        i--;
    }
    int nb = (n + buben - 1) / buben;
    vector<int> num(n);
    vector<int> pos(n);
    for(int i = 0; i < n; i++) {
        pos[a[i]] = i;
    }
    for(int i = 0; i < n; i++) {
        num[i] = i / buben;
    }
    vector<int> lf(nb), rt(nb);
    for(int i = 0; i < nb; i++) {
        lf[i] = i * buben;
        rt[i] = min(i * buben + buben - 1, n - 1);
    }
    vector<fenwick> c(nb);
    ll ans = 0;
    for(int i = 0; i < n; i++) {
        int bl = num[i];
        c[bl].update(a[i], 1);
    }
    for(int i = 0; i < n; i++) {
        int x = a[i];
        int bl = num[i];
        for(int j = 0; j < bl; j++) {
            ans += c[j].get(x + 1, n - 1);
        }
        for(int j = lf[bl]; j < i; j++) {
            ans += (a[j] > a[i]);
        }
    }
    int q = n - 2;
    cout << ans << " ";
    while(q--) {
        int x;
        cin >> x;
        x--;
        int p = pos[x];
        int bl = num[p];
        for(int i = 0; i < bl; i++) {
            ans -= c[i].get(x + 1, n - 1);
        }
        for(int i = bl + 1; i < nb; i++) {
            ans -= c[i].get(x);
        }
        for(int i = lf[bl]; i < p; i++) {
            if(!~a[i]) {
                continue;
            }
            ans -= (a[i] > x);
        }
        for(int i = p + 1; i <= rt[bl]; i++) {
            if(!~a[i]) {
                continue;
            }
            ans -= (a[i] < x);
        }
        c[bl].update(p, -1);
        a[p] = -1;
        cout << ans << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    solve();
}
