#include <bits/stdc++.h>

using namespace std;
using ll = long long;

// const int K = 120;
// const int mxN = 15005;

const int K = 120;
const int mxN = 15005;

struct Seg {
    vector<int> seg;
    int n;
    Seg(int n) : n(n), seg(2 * n) {}
    void update(int i, int x) {
        i += n;
        seg[i] += x;
        for (i >>= 1; i; i >>= 1) {
            seg[i] = seg[i << 1] + seg[(i << 1) | 1];
        }
    }
    int query(int a, int b) {
        int res = 0;
        for (a += n, b += n; a < b; a >>= 1, b >>= 1) {
            if (a & 1) {
                res += seg[a++];
            }
            if (b & 1) {
                res += seg[--b];
            }
        }
        return res;
    }
};

vector<Seg> segs((mxN + K - 1) / K, Seg(mxN));

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;
    vector<int> ps(n);
    vector<int> lc(n);
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        x--;
        lc[i] = x;
        ps[x] = i;
    }
    // for (int i = 0; i < n; i++) {
    //     cout << i << " | ";
    // }
    // cout << "\n";
    // for (int p : ps) {
    //     cout << p << " | ";
    // }
    // cout << "\n";
    vector<bool> alive(n, true);
    vector<int> xs(n - 2);
    for (int &x : xs) {
        cin >> x;
        x--;
        alive[ps[x]] = false;
    }
    ll res = 0;
    int sc = -1;
    for (int i = 0; i < n; i++) {
        if (alive[i]) {
            segs[i / K].update(lc[i], 1);
            if (sc != -1) {
                if (lc[sc] > lc[i]) {
                    res = 1;
                }
            }
            sc = i;
        }
    }
    reverse(xs.begin(), xs.end());
    vector<ll> rs = {res};
    for (int x : xs) {
        // cout << "ADD " << x << endl;
        int p = ps[x];
        int c = p / K;
        int l = c * K;
        int r = min(l + K, n);
        for (int i = l; i < p; i++) {
            res += (alive[i] && lc[i] > x);
        }
        for (int i = p + 1; i < r; i++) {
            res += (alive[i] && lc[i] < x);
        }
        for (int ci = (n - 1) / K; ci >= c + 1; ci--) {
            // cout << " + " << segs[ci].query(x, n) << " (" << K * ci << " - "
            //      << (K * ci + K - 1) << ")" << endl;
            res += segs[ci].query(0, x);
        }
        for (int ci = 0; ci < c; ci++) {
            // cout << " + " << segs[ci].query(x, n) << " (" << K * ci << " - "
            //      << (K * ci + K - 1) << ")" << endl;
            res += segs[ci].query(x, n);
        }
        rs.push_back(res);
        // cout << "OP " << x << " (" << c << ")" << endl;
        segs[c].update(x, 1);
        alive[ps[x]] = true;
    }
    reverse(rs.begin(), rs.end());
    for (ll r : rs) {
        cout << r << " ";
    }
    cout << "\n";
    return 0;
}

/*

6
6 1 2 5 3 4
3 5 4 6

6 1 2 5 3 4 - 7
6 1 2 5 4   - 5
6 1 2 4     - 3
6 1 2       - 2
1 2         - 0
*/