#include <bits/stdc++.h>

using namespace std;
using ll = long long;

// const int K = 120;
// const int mxN = 15005;

const int K = 1000;
const int mxN = 1e5 + 2;

struct Seg {
    vector<int> seg;
    int n;
    Seg(int n) : n(n), seg(2 * n) {}
    void update(int i, int x) {
        i += n;
        seg[i] += x;
        for (i >>= 1; i; i >>= 1) {
            seg[i] = seg[i << 1] + seg[(i << 1) | 1];
        }
    }
    int query(int a, int b) {
        int res = 0;
        for (a += n, b += n; a < b; a >>= 1, b >>= 1) {
            if (a & 1) {
                res += seg[a++];
            }
            if (b & 1) {
                res += seg[--b];
            }
        }
        return res;
    }
};

const int mxC = (mxN + K - 1) / K;

vector<Seg> segs(mxC, Seg(K));
vector<int> idxs[mxC];
vector<int> as[mxC];

int n;
int get_idx(int c, int i) {
    if (i == n) {
        return idxs[c].size();
    }
    int l = 0, r = idxs[c].size();
    while (l < r) {
        int mid = (l + r) / 2;
        int cur = idxs[c][mid];
        if (cur < i) {
            l = mid + 1;
        } else {
            r = mid;
        }
    }
    return l;
}

void update(int c, int i, int x) { segs[c].update(get_idx(c, i), x); }

int query(int c, int a, int b) {
    return segs[c].query(get_idx(c, a), get_idx(c, b));
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n;
    vector<int> ps(n);
    vector<int> lc(n);
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        x--;
        lc[i] = x;
        ps[x] = i;
    }
    for (int i = 0; i < n; i++) {
        idxs[ps[i] / K].push_back(i);
    }
    // for (int i = 0; i < n; i++) {
    //     cout << i << " | ";
    // }
    // cout << "\n";
    // for (int p : ps) {
    //     cout << p << " | ";
    // }
    // cout << "\n";
    vector<bool> alive(n, true);
    vector<int> xs(n - 2);
    for (int &x : xs) {
        cin >> x;
        x--;
        alive[ps[x]] = false;
    }
    ll res = 0;
    int sc = -1;
    for (int i = 0; i < n; i++) {
        if (alive[i]) {
            as[i / K].push_back(i);
            update(i / K, lc[i], 1);
            if (sc != -1) {
                if (lc[sc] > lc[i]) {
                    res = 1;
                }
            }
            sc = i;
        }
    }
    reverse(xs.begin(), xs.end());
    vector<ll> rs = {res};
    for (int x : xs) {
        // cout << "ADD " << x << endl;
        int p = ps[x];
        int c = p / K;
        int l = c * K;
        int r = min(l + K, n);
        for (int a : as[c]) {
            res += ((a > p) ^ (lc[a] > x));
        }
        // for (int i = l; i < p; i++) {
        //     res += (alive[i] && lc[i] > x);
        // }
        // for (int i = p + 1; i < r; i++) {
        //     res += (alive[i] && lc[i] < x);
        // }
        for (int ci = (n - 1) / K; ci >= c + 1; ci--) {
            // cout << " + " << segs[ci].query(x, n) << " (" << K * ci << " - "
            //      << (K * ci + K - 1) << ")" << endl;
            res += segs[ci].query(0, get_idx(ci, x));
        }
        for (int ci = 0; ci < c; ci++) {
            // cout << " + " << segs[ci].query(x, n) << " (" << K * ci << " - "
            //      << (K * ci + K - 1) << ")" << endl;
            res += segs[ci].query(get_idx(ci, x), K);
        }
        rs.push_back(res);
        // cout << "OP " << x << " (" << c << ")" << endl;
        update(c, x, 1);
        // alive[ps[x]] = true;
        as[c].push_back(p);
    }
    reverse(rs.begin(), rs.end());
    for (ll r : rs) {
        cout << r << " ";
    }
    cout << "\n";
    return 0;
}

/*

6
6 1 2 5 3 4
3 5 4 6

6 1 2 5 3 4 - 7
6 1 2 5 4   - 5
6 1 2 4     - 3
6 1 2       - 2
1 2         - 0
*/