#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<pii> vp;
typedef vector<vp> vvp;
typedef vector<bool> vb;
typedef vector<vb> vvb;



struct segmentTree
{
	vll st;
	int size;
	segmentTree() {};
	segmentTree(int n) {
		for (size = 1; size < n; size *= 2) {};
		st.resize(2 * size);
	}

	void update(int i, int x) {
		i += size;
		st[i] = x;
		for (i /= 2; i; i /= 2) {
			st[i] = st[i * 2] + st[i * 2 + 1];
		}
	}

	ll query(int l, int r) {
		ll ans = 0;
		for (l += size, r += size; l <= r; l /= 2, r /= 2) {
			if (l % 2) {
				ans += st[l];
				l++;
			}
			if (r % 2 == 0) {
				ans += st[r];
				r--;
			}
		}
		return ans;
	}
};

segmentTree st;
vi arr;
vi id;
int N;

ll diff(int ind, int x) {
	ll counter = 0;
	for (int i = 0; i < ind; i++) {
		if (arr[i] != -1 && arr[i] > x) counter++;
	}

	for (int i = ind + 1; i < arr.size(); i++) {
		if (arr[i] != -1 && arr[i] < x) counter++;
	}
	return counter;
}

ll count() {
	ll ans = 0;
	for (int i = 0; i < arr.size(); i++) {
		int curr = st.query(arr[i], N - 1);
		ans += curr;
		st.update(arr[i], 1);
	}
	return ans;

}

/*
void removeCard(int x) {
	vi newarr;
	for (int i = 0; i < arr.size(); i++) {
		if (arr[i] == x) continue;
		newarr.push_back(arr[i]);
	}
	arr = newarr;
}
*/

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	int n;
	cin >> n;
	N = n;
	st = segmentTree(n);
	arr.resize(n);
	id.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
		arr[i]--;
		id[arr[i]] = i;
	}

	vll ans(n - 1);
	ll keep = count();
	ans[0] = keep;
	ll curr;
	for (int i = 1; i < n - 1; i++) {
		cin >> curr;
		curr--;
		ll cd = diff(id[curr], curr);
		keep -= cd;
		ans[i] = keep;
		arr[id[curr]] = -1;
		//removeCard(curr - 1);
	}
	//ans[n-2] = count();


	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i] << " ";
	}


	return 0;
}