#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define x first
#define y second
#define all(v) v.begin(), v.end()
#define chkmax(a, b) a = max(a, b)
#define chkmin(a, b) a = min(a, b)
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef vector<pii> vii;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int MAX_N = 1e5 + 5;

struct Seg1 {
    vi seg, lp, rp;
    int n;
    Seg1() {}
    Seg1(int n): n(n) {
        Add();
    }
    void Add() {
        lp.push_back(0), rp.push_back(0), seg.push_back(0);
    }
    void update(int i, int x, int ind, int l, int r) {
        seg[ind] += x;
        if (l + 1 == r) return;
        if (i < (l + r) >> 1) {
            if (!lp[ind]) {
                lp[ind] = seg.size();
                Add();
            }
            update(i, x, lp[ind], l, (l + r) >> 1);
        } else {
            if (!rp[ind]) {
                rp[ind] = seg.size();
                Add();
            }
            update(i, x, rp[ind], (l + r) >> 1, r);
        }
    }
    inline void update(int i, int x) {
        update(i, x, 0, 0, n);
    }
    int query(int a, int b, int ind, int l, int r) {
        if (a <= l && r <= b) return seg[ind];
        if (r <= a || b <= l) return 0;
        return (lp[ind] ? query(a, b, lp[ind], l, (l + r) >> 1) : 0) +
                (rp[ind] ? query(a, b, rp[ind], (l + r) >> 1, r) : 0);
    }
    inline int query(int a, int b) {
        return query(a, b, 0, 0, n);
    }
};

struct Seg2 {
    vector<Seg1> seg;
    int n;
    Seg2() {}
    Seg2(int m) {
        for (n = 1; n < m; n <<= 1);
        seg.resize(2 * n, Seg1(m));
    }
    void update(int i, int j, int x) {
        for (i += n; i; i >>= 1) seg[i].update(j, x);
    }
    int query(int x1, int y1, int x2, int y2) {
        int ans = 0;
        for (x1 += n, x2 += n; x1 < x2; x1 >>= 1, x2 >>= 1) {
            if (x1 & 1) ans += seg[x1++].query(y1, y2);
            if (x2 & 1) ans += seg[--x2].query(y1, y2);
        }
        return ans;
    }
};


int a[MAX_N], ind[MAX_N];
int que[MAX_N];
ll ans[MAX_N];
int n;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n - 2; i++) cin >> que[i];
    ordered_set s;
    ll c = 0;
    for (int i = n - 1; i >= 0; i--) {
        c += s.order_of_key(a[i]);
        s.insert(a[i]);
    }
    Seg2 seg(n + 1);
    for (int i = 0; i < n; i++) {
        seg.update(i, a[i], 1);
        ind[a[i]] = i;
    }
    ans[0] = c;
    for (int i = 0; i < n - 2; i++) {
        int j = ind[que[i]];
        seg.update(j, a[j], -1);
        c -= seg.query(0, a[j], j, n + 1);
        c -= seg.query(j, 0, n + 1, a[j]);
        ans[i + 1] = c;
    }
    for (int i = 0; i <= n - 2; i++) cout << ans[i] << ' ';
}
