#pragma GCC optimize ("O3")

#include "bits/stdc++.h"
using namespace std;

const int N = 1.5e4 + 5;

#define ll long long

struct node {
    node *left, *right;
    ll sum;
    node() {
        sum = 0;
        left = right = NULL;
    }
};
int get(node* a) {
    if(a == NULL) return 0;
    return a->sum;
}
void modify(node*& u, int l, int r, int pos, int val) {
    if(u == NULL) u = new node();
    if(l > pos || r < pos) return;
    if(l >= pos && r <= pos) {
        u->sum = val;
        return;
    }
    int mid = (l + r) >> 1;
    modify(u->left, l, mid, pos, val);
    modify(u->right, mid + 1, r, pos, val);
    u->sum = get(u->left) + get(u->right);
}
int queryy(node* u, int l, int r, int tl, int tr) {
    if(u == NULL || l > tr || r < tl) return 0;
    if(l >= tl && r <= tr) return u->sum;
    int mid = l + r >> 1;
    return queryy(u->left, l, mid, tl, tr) + queryy(u->right, mid + 1, r, tl, tr);
}

struct f {
    f *left, *right;
    node* s;
    f() {
        s = NULL;
        left = right = NULL;
    }
};
void modifx(f*& u, int l, int r, int x, int y, int val) {
    if(u == NULL) u = new f();
    if(l > x || r < x) return;
    if(l >= x && r <= x) {
        modify(u->s, 0, N, y, val);
        return;
    }
    int mid = (l + r) >> 1;
    modifx(u->left, l, mid, x, y, val);
    modifx(u->right, mid + 1, r, x, y, val);
    ll new_val = queryy(u->left->s, 0, N, l, r) + queryy(u->right->s, 0, N, l, r);
    modify(u->s, 0, N, y, val);
}
int queryx(f* u, int l, int r, int tlx, int trx, int tly, int tryy) {
    if(u == NULL || l > trx || r < tlx) return 0;
    if(l >= tlx && r <= trx) {
        return queryy(u->s, 0, N, tly, tryy);
    }
    int mid = (l + r) >> 1;
    return queryx(u->left, l, mid, tlx, trx, tly, tryy) + queryx(u->right, mid + 1, r, tlx, trx, tly, tryy);
}

f* root;

int main(){
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    root = new f();
    int n; cin >> n;
    int a[n];
    ll ans = 0;
    int pos[n + 1];
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
        pos[a[i]] = i;
        modifx(root, 0, N, i, a[i], 1);
    }
    for(int i = 0; i < n; ++i) {
        ans += queryx(root, 0, N, i + 1, n, 0, a[i]);
    }
    int o[n - 1];
    o[0] = ans;
    for(int c = 0; c < n - 2; ++c) {
        int x; cin >> x;
        ans -= queryx(root, 0, N, pos[x] + 1, n, 0, x) + queryx(root, 0, N, 0, pos[x], x + 1, n);
        if(!ans) {
            for(int j = c; j < n - 1; ++j) o[j] = 0;
            break;
        }
        modifx(root, 0, N, pos[x], x, 0);
        o[c + 1] = ans;
    }
    for(int i = 0; i < n - 1; ++i) cout << o[i] << " ";
}
/*
6
6 1 2 5 3 4
3 5 4 6
*/
