#pragma GCC optimize ("O3")

#include "bits/stdc++.h"
using namespace std;

const int N = 1.5e4 + 5;

#define ll long long

struct fenwick {
    int fen[N];
    fenwick() {
        for(int i = 0; i < N; ++i) fen[i] = 0;
    }
    void modif(int u, int val) {
        for(int i = u + 1; i < N; i += i & -i) fen[i] += val;
    }
    int query(int l, int r) {
        int ans = 0;
        for(int i = r + 1; i >= 1; i -= i & -i) ans += fen[i];
        for(int i = l; i >= 1; i -= i & -i) ans -= fen[i];
        return ans;
    }
};

struct f {
    f *left, *right;
    fenwick s;
    f() {
        left = right = NULL;
    }
};
void modifx(f*& u, int l, int r, int x, int y, int val) {
    if(u == NULL) u = new f();
    if(l > x || r < x) return;
    if(l >= x && r <= x) {
        u->s.modif(y, val);
        return;
    }
    int mid = (l + r) >> 1;
    modifx(u->left, l, mid, x, y, val);
    modifx(u->right, mid + 1, r, x, y, val);
    int new_val = u->left->s.query(y, y) + u->right->s.query(y, y);
    int prev = u->s.query(y, y);
    u->s.modif(y, new_val - prev);
}
int queryx(f* u, int l, int r, int tlx, int trx, int tly, int tryy) {
    if(u == NULL || l > trx || r < tlx) return 0;
    if(l >= tlx && r <= trx) {
        return u->s.query(tly, tryy);
    }
    int mid = (l + r) >> 1;
    return queryx(u->left, l, mid, tlx, trx, tly, tryy) + queryx(u->right, mid + 1, r, tlx, trx, tly, tryy);
}

f* root;

int main(){
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    root = new f();
    int n; cin >> n;
    int a[n];
    ll ans = 0;
    int pos[n + 1];
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
        pos[a[i]] = i;
        modifx(root, 0, N, i, a[i], 1);
    }
    for(int i = 0; i < n; ++i) {
        ans += queryx(root, 0, N, i + 1, n, 0, a[i]);
    }
    int o[n - 1];
    o[0] = ans;
    int input[n - 2];
    for(int c = 0; c < n - 2; ++c) cin >> input[c];

    for(int c = 0; c < n - 2; ++c) {
        int x = input[c];
        ans -= queryx(root, 0, N, pos[x] + 1, n, 0, x) + queryx(root, 0, N, 0, pos[x], x + 1, n);
        modifx(root, 0, N, pos[x], x, -1);
        o[c + 1] = ans;
    }
    for(int i = 0; i < n - 1; ++i) cout << o[i] << " ";
}
/*
6
6 1 2 5 3 4
3 5 4 6
*/
