#pragma GCC optimize("O3")

#include "bits/stdc++.h"
using namespace std;

const int N = 1e5 + 10;

#define ll long long

struct node {
    node *left, *right;
    ll sum;
    node() {
        sum = 0;
        left = right = NULL;
    }
};
int get(node* a) {
    if(a == NULL) return 0;
    return a->sum;
}
void modify(node*& u, int l, int r, int pos, int val) {
    if(u == NULL) u = new node();
    if(l > pos || r < pos) return;
    if(l >= pos && r <= pos) {
        u->sum = val;
        return;
    }
    int mid = (l + r) >> 1;
    modify(u->left, l, mid, pos, val);
    modify(u->right, mid + 1, r, pos, val);
    u->sum = get(u->left) + get(u->right);
}
int queryy(node* u, int l, int r, int tl, int tr) {
    if(u == NULL || l > tr || r < tl) return 0;
    if(l >= tl && r <= tr) return u->sum;
    int mid = l + r >> 1;
    return queryy(u->left, l, mid, tl, tr) + queryy(u->right, mid + 1, r, tl, tr);
}

node* fen[N];
void modif(int x, int y, int val) {
    for(int i = x + 1; i < N; i += i & -i) modify(fen[i], 0, N, y, val);
}
ll query(int lx, int rx, int ly, int ry) {
    ll ans = 0;
    for(int i = rx + 1; i >= 1; i -= i & -i) ans += queryy(fen[i], 0, N, ly, ry);
    for(int i = lx; i >= 1; i -= i & -i) ans -= queryy(fen[i], 0, N, ly, ry);
    return ans;
}

int main(){
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    int n; cin >> n;
    int a[n];
    ll ans = 0;
    vector<int> pos(n + 1, -1);
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
        pos[a[i]] = i;
        modif(i, a[i], 1);
    }
    for(int i = 0; i < n; ++i) {
        ans += query(i + 1, n, 0, a[i]);
    }
    int o[n - 1];
    o[0] = ans;
    for(int c = 0; c < n - 2; ++c) {
        int x; cin >> x;
        ans -= query(pos[x] + 1, n, 0, x) + query(0, pos[x], x + 1, n);
        modif(pos[x], x, 0);
        o[c + 1] = ans;
    }
    for(int i = 0; i < n - 1; ++i) cout << o[i] << " ";
}
/*
6
6 1 2 5 3 4
3 5 4 6
*/
