#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>

using namespace std;

const int maxN = 100001;
int n, v[maxN], poz[maxN], upd[maxN];
vector <long long> ans;
bool scos[maxN];
vector <int> aib[maxN], on[maxN];

int lsb(int x)
{
    return (x & (-x));
}

void preupdate(int x, int y)
{
    for(int i = x; i <= n; i += lsb(i))
        on[i].push_back(y);
}

void preprocess()
{
    for(int i = 1; i <= n; i++)
    {
        on[i].push_back(0);
        sort(on[i].begin(), on[i].end());
        aib[i].resize(on[i].size());
    }
}

void update(int x, int y)
{
    for(int i = x; i <= n; i += lsb(i))
    {
        int it = lower_bound(on[i].begin(), on[i].end(), y) - on[i].begin();
        for(int j = it; j < aib[i].size(); j += lsb(j))
            aib[i][j]++;
    }
}

long long query(int x, int y)
{
    long long aux = 0;
    for(int i = x; i; i -= lsb(i))
    {
        int it = upper_bound(on[i].begin(), on[i].end(), y) - 1 - on[i].begin();
        for(int j = it; j; j -= lsb(j))
            aux += aib[i][j];
    }
    return aux;
}

int main()
{
    cin >> n;
    for(int i = 1; i <= n; i++)
    {
        cin >> v[i];
        poz[v[i]] = i;
        preupdate(i, v[i]);
    }
    preprocess();
    for(int i = n - 2; i >= 1; i--)
    {
        cin >> upd[i];
        scos[upd[i]] = 1;
    }
    int x, y;
    for(int i = 1; i <= n; i++)
    {
        if(!scos[i])
        {
            update(poz[i], i);
            y = x;
            x = i;
        }
    }
    ans.resize(n - 1);
    if(poz[y] > poz[x])
        ans[0] = 1;
    for(int i = 1; i <= n - 2; i++)
    {
        ans[i] = ans[i - 1];
        ans[i] += query(poz[upd[i]] - 1, n);
        ans[i] -= query(poz[upd[i]] - 1, upd[i]);
        ans[i] += query(n, upd[i]);
        ans[i] -= query(poz[upd[i]], upd[i]);
        update(poz[upd[i]], upd[i]);
    }
    for(int i = n - 2; i >= 0; i--)
        cout << ans[i] << ' ';
    return 0;
}
