#include <bits/stdc++.h>

using namespace std;
unsigned seed = chrono :: system_clock :: now().time_since_epoch().count();
mt19937 rng(seed);
struct treap {
    int x;
    int pr, sz;
    treap *l, *r;
    treap(int x) : x(x), pr(rng()), sz(1), l(NULL), r(NULL) {}
    friend int size(treap *t) { return t ? t -> sz : 0; }
    friend void update(treap *t) {
        if(!t) return;
        t -> sz = 1 + size(t -> l) + size(t -> r);
    }
};
treap *merge(treap *l, treap *r) {
    if(!l) return r;
    if(!r) return l;
    if(l -> pr >= r -> pr) {
        l -> r = merge(l -> r, r);
        update(l);
        return l;
    } else {
        r -> l = merge(l, r -> l);
        update(r);
        return r;
    }
}
array <treap*, 2> x_split(treap *t, int x) {
    if(!t) return {NULL, NULL};
    if(t -> x >= x) {
        auto [l, r] = x_split(
                              t -> l, x);
        t -> l = r;
        update(t);
        return {l, t};
    } else {
        auto [l, r] = x_split(
                              t -> r, x);
        t -> r = l;
        update(t);
        return {t, r};
    }
}
array <treap*, 2> split(treap *t, int k) {
    if(!t) return {NULL, NULL};
    if(size(t -> l) >= k) {
        auto [l, r] = split(t -> l, k);
        t -> l = r;
        update(t);
        return {l, t};
    } else {
        auto [l, r] = split(t -> r, k - size(t -> l) - 1);
        t -> r = l;
        update(t);
        return {t, r};
    }
}
treap *erase(treap *t, int x) {
    auto [l, r] = x_split(t, x);
    return merge(l, split(r, 1)[1]);
}
const int N = 1e5 + 5;
vector <treap*> f1, f2;
int n;
vector <int> t1[N], t2[N];
void add(vector <int>* t, int pos, int x) {
    for(; pos <= n; pos += pos & -pos)
        t[pos].push_back(x);
}
int a[N], r[N];
int bit[N];
void add(int* t, int pos, int x) {
    for(; pos <= n; pos += pos & -pos)
        t[pos] += x;
}
int query(int *t, int pos) {
    int res = 0;
    for(; pos; pos -= pos & -pos)
        res += t[pos];
    return res;
}
void update(vector <treap*>& t, int pos, int x) {
//    cerr << "Update " << pos << " " << x << "\n";
    for(; pos <= n; pos += pos & -pos) {
//        cerr << pos << "\n";
        t[pos] = erase(t[pos], x);
    }
}
int query(vector <treap*>& t, int pos, int x) {
    int res = 0;
//    cerr << "Query " << pos << " " << x << "\n";
    for(; pos; pos -= pos & -pos) {
//        cerr << pos << "\n";
        auto [l, r] = x_split(t[pos], x);
        res += size(l);
        t[pos] = merge(l, r);
    }
    return res;
}

int main()
{
    ios_base :: sync_with_stdio(false); cin.tie(0);
    cin >> n;
    for(int i = 1; i <= n; i++) {
        cin >> a[i];
//        r[a[i]] = i;
    }
    reverse(a + 1, a + n + 1);
    for(int i = 1; i <= n; i++)
        r[a[i]] = i;
    for(int i = 1; i <= n; i++) {
        add(t1, i, a[i]);
        add(t2, n + 1 - i, n + 1 - a[i]);
    }
    for(int i = 1; i <= n; i++) {
        sort(t1[i].begin(), t1[i].end());
        sort(t2[i].begin(), t2[i].end());
    }
    f1.resize(n + 1, NULL); f2.resize(n + 1, NULL);
    for(int i = 1; i <= n; i++) {
        f1[i] = NULL; f2[i] = NULL;
        for(int x : t1[i])
            f1[i] = merge(f1[i], new treap(x));
        for(int x : t2[i])
            f2[i] = merge(f2[i], new treap(x));
    }
    int res = 0;
    for(int i = 1; i <= n; i++) {
        res += query(bit, a[i]);
        add(bit, a[i], 1);
    }
    cout << res << " ";
    for(int i = 1; i < n - 1; i++) {
        int x;
//        cerr << "Query " << i << "\n";
        cin >> x;
//        cout << x << " at pos " << i << "\n";
//        cout << "Smaller left: " << query(f1, r[x]-1, x) << "\n";
//        cout << "Bigger right: " << query(f2, n+1-r[x]-1, n+1-x) << "\n";
        res -= query(f1, r[x]-1, x);
        res -= query(f2, n+1-r[x]-1, n+1-x);
        update(f1, r[x], x);
        update(f2, n+1-r[x], n+1-x);
        cout << res << " ";
    }
    return 0;
}
