#include <bits/stdc++.h>
#define fin cin
#define fout cout

using namespace std;

//ifstream fin("f.in");
//ofstream fout("f.out");

const int NMAX = 1e5 + 1;

vector<int> aib[NMAX * 4], arr[NMAX * 4];
int vals[NMAX], posv[NMAX];


void aibUpd(vector<int> &aib, int pos, int delta);
int aibQuery(vector<int> &aib, int pos);
int lefts(int nd);
int rights(int nd);
void build(int nd, int l, int r);
int bs(vector<int> &v, int val);
void del(int nd, int l, int r, int val);
int querysm(int nd, int l, int r, int ql, int qr, int val);
int querybg(int nd, int l, int r, int ql, int qr, int val);


int main() {
    int n;

    fin >> n;
    for (int i = 1; i <= n; i++) {
        fin >> vals[i];
        posv[vals[i]] = i;

    }

    build(1, 1, n);


    long long total = 0;
    for (int i = 1; i <= n; i++)
        total += querysm(1, 1, n, i + 1, n, vals[i]);

    fout << total << " ";
    for (int i = 1; i < n - 1; i++) {
        int nr;
        fin >> nr;

        total -= (querysm(1, 1, n, posv[nr] + 1, n, nr) + querybg(1, 1, n, 1, posv[nr] - 1, nr));
        del(1, 1, n, nr);
        fout << total << " ";
    }
    return 0;
}

void aibUpd(vector<int> &aib, int pos, int delta) {
    int n = aib.size();
    for (; pos <= n; pos += (pos & -pos))
        aib[pos] += delta;
}

int aibQuery(vector<int> &aib, int pos) {
    int s = 0;
    for(; pos; pos -= (pos & -pos))
        s += aib[pos];
    return s;
}

int lefts(int nd) {
    return nd << 1;
}

int rights(int nd) {
    return (nd << 1) + 1;
}

void build(int nd, int l, int r) {

    aib[nd].resize(r - l + 2);
    for (int i = l; i <= r; i++) {
        arr[nd].push_back(vals[i]);
        aibUpd(aib[nd], i - l + 1, 1);
    }
    sort(arr[nd].begin(), arr[nd].end());

    if (l == r)
        return;

    int mid = (l + r) / 2;
    build(lefts(nd), l, mid);
    build(rights(nd), mid + 1, r);
}

int bs(vector<int> &v, int val) {

    int pos = 0, step = (1 << 16), sz = v.size();
    while (step) {
        if (pos + step < sz && v[pos + step] < val)
            pos += step;
        step >>= 1;
    }

    return pos;
}

void del(int nd, int l, int r, int val) {
    if (l == r) {
        aibUpd(aib[nd], 1, -1);
        return;
    }

    int pos = bs(arr[nd], val) + 2;
    if (arr[nd][0] == val)
        pos = 1;
    aibUpd(aib[nd], pos, -1);

    int mid = (l + r) / 2;
    if (mid >= posv[val])
        del(lefts(nd), l, mid, val);
    else
        del(rights(nd), mid + 1, r, val);
}

int querysm(int nd, int l, int r, int ql, int qr, int val) {
    if (ql > r || qr < l)
        return 0;

    if (ql <= l && r <= qr) {
        int pos = bs(arr[nd], val);
        if (arr[nd][pos] < val)
            pos++;
        return aibQuery(aib[nd], pos);
    }

    int mid = (l + r) / 2;
    return querysm(lefts(nd), l, mid, ql, qr, val) + querysm(rights(nd), mid + 1, r, ql, qr, val);
}

int querybg(int nd, int l, int r, int ql, int qr, int val) {
    if (ql > r || qr < l)
        return 0;

    if (ql <= l && r <= qr) {
        int pos = bs(arr[nd], val);

        if (arr[nd][pos] < val)
                pos++;

        return aibQuery(aib[nd], arr[nd].size()) - aibQuery(aib[nd], pos);
    }

    int mid = (l + r) / 2;
    return querybg(lefts(nd), l, mid, ql, qr, val) + querybg(rights(nd), mid + 1, r, ql, qr, val);
}
