#include <iostream>
#include <vector>
#include <cmath>
#include <cassert>
#include <algorithm>

using ll = long long;

int const nmax = 100000;
int v[5 + nmax], p[5 + nmax];
ll answer[5 + nmax];

struct Info{
  int val;
  int id;
  int color;
  int color2;
  bool operator < (Info const oth) {
    return val < oth.val;
  }
};

Info arr[5 + nmax];
Info arr2[5 + nmax];

void divideBack(int from, int to) {
  if(from == to)
    return ;
  int mid = (from + to) / 2;
  divideBack(from, mid);
  divideBack(mid + 1, to);
  
  std::vector<Info> temp(to - from + 1);
  for(int i = from; i <= mid; i++)
    arr2[i].color2 = 0;
  for(int i = mid + 1; i <= to; i++)
    arr2[i].color2 = 1;

  std::merge(arr2 + from, arr2 + mid + 1,
             arr2 + mid + 1, arr2 + to + 1,
             temp.begin());
  for(int i = 0; i < temp.size(); i++)
    arr2[i + from] = temp[i];
  
  int count[2][2] = {0, 0, 0, 0};
  for(int i = to; from <= i; i--) {
    if(arr2[i].color != arr2[i].color2) {
      count[arr2[i].color][arr2[i].color2]++;
      answer[arr2[i].val] += count[!arr2[i].color][!arr2[i].color2];
    }
  }
}

void divide(int from, int to) {
  if(from == to)
    return ;
  int mid = (from + to) / 2;
  divide(from, mid);
  divide(mid + 1, to);
  for(int i = from; i <= mid; i++)
    arr[i].color = 0;
  for(int i = mid + 1; i <= to; i++)
    arr[i].color = 1;
  
  std::vector<Info> temp(to - from + 1);
  std::merge(arr + from, arr + mid + 1, 
             arr + mid + 1, arr + to + 1,
             temp.begin());
  for(int i = 0; i < temp.size(); i++)
    arr[i + from] = temp[i];
  for(int i = from; i <= to; i++) {
    arr2[i] = arr[i];
    arr2[i].val = p[arr[i].val];
  }
  divideBack(from, to);  
}

void build(int n) {
  for(int i = 1; i <= n; i++)
    arr[i] = {v[i], i, 0, 0};
}

int main() {
  std::ios::sync_with_stdio(0);
  std::cin.tie(0);

  int n;
  std::cin >> n;
  for(int i = 1;i <= n; i++)
    std::cin >> v[i];
  for(int i = 1;i <= n; i++)
    p[i] = n;
  build(n);
  for(int i = 1;i <= n - 2; i++) {
    int val;
    std::cin >> val;
    p[val] = i;
  }

  divide(1, n);
  for(int i = n - 1; 1 <= i; i--)
    answer[i] += answer[i + 1];
  for(int i = 1; i <= n - 1; i++)
    std::cout << answer[i] << " ";
  std::cout << '\n';
  return 0;
}
