#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using os = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

struct SegTree {
    struct node {
        os s;

        int64_t count_less(int x) {
            return s.order_of_key(x);
        }

        int64_t count_more(int x) {
            return s.size() - count_less(x);
        }
    };

    static const int offset = (1 << 17);
    node aint[2 * offset];

    void update(int poz, int val) {
        for(poz += offset; poz >= 1; poz /= 2) aint[poz].s.insert(val);
    }

    int query(int node, int l, int r, int gl, int gr, int tip, int x) {
        if(r < gl || gr < l) return 0;

        if(gl <= l && r <= gr) {
            if(tip == 1) return aint[node].count_less(x);
            if(tip == 2) return aint[node].count_more(x);
        }

        int mid = (l + r) / 2;
        return query(2 * node, l, mid, gl, gr, tip, x) + query(2 * node + 1, mid + 1, r, gl, gr, tip, x);
    }

    int64_t inv = 0;
    void add_inv(int poz, int val) {
        inv += 1LL * query(1, 0, offset - 1, 0, poz, 2, val);
        inv += 1LL * query(1, 0, offset - 1, poz, offset - 1, 1, val);
        update(poz,val);
    }
};

SegTree st;
const int NMAX = 1e5 + 7;
int v[NMAX], inv[NMAX];
int order[NMAX];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n; cin >> n;
    set<int> ind;
    for(int i = 0; i < n; i++) { cin >> v[i]; inv[v[i]] = i; ind.insert(i); }

    for(int i = 0; i < n - 2; i++) {
        cin >> order[i]; order[i] = inv[order[i]];
        ind.erase(order[i]);
    }

    while(ind.size()) {
        order[n - ind.size()] = *ind.begin();
        ind.erase(ind.begin());
    }

    vector<int64_t> ret;
    for(int i = n - 1; i >= 0; i--) {
        st.add_inv(order[i], v[order[i]]);
        ret.push_back(st.inv);
    }

    reverse(ret.begin(), ret.end());
    ret.pop_back();
    for(auto e : ret) cout << e << " ";

    return 0;
}
