#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

const int NMAX = 1e5 + 1237;
int timer;
struct Aib2D {
    struct Aib {
        map<int, int> norm;
        vector<int> aib;

        void init() {
            int x = 1;
            for(auto &e : norm) e.second = x++;
            aib.resize(norm.size() + 7);
        }

        void update(int poz, int val) {
            if(timer == 1) {
                norm[poz] = 1;
                return;
            }
            if(timer == 2) {
                poz = norm[poz];
            }

            for(; poz < aib.size(); poz += poz & (-poz))
                aib[poz] += val;
        }

        int query(int poz) {
            if(timer == 1) {
                norm[poz] = 1;
                return 0;
            }
            if(timer == 2) {
                poz = norm[poz];
            }

            int ret = 0;
            for(; poz > 0; poz -= poz & (-poz))
                ret += aib[poz];
            return ret;
        }
    };
    vector<Aib> aib;
    void init() {
        for(auto &e : aib) e.init();
    }

    void update(int x, int y) {
        x += 7; y += 7;

        for(; x < NMAX; x += x & (-x))
            aib[x].update(y, 1);
    }

    int64_t query(int x, int y) {
        x += 7; y += 7;
        int64_t ret = 0;
        for(; x > 0; x -= x & (-x))
            ret += aib[x].query(y);
        return ret;
    }

    Aib2D() : aib(NMAX) {;}
    
} a2d;

int v[NMAX], inv[NMAX];
int order[NMAX];

int main() {
#ifdef LOCAL
    cerr << "Compiled!" << endl;
#endif // LOCAL

    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n; cin >> n;
    set<int> ind;
    for(int i = 0; i < n; i++) { cin >> v[i]; inv[v[i]] = i; ind.insert(i); }

    for(int i = 0; i < n - 2; i++) {
        cin >> order[i]; order[i] = inv[order[i]];
        ind.erase(order[i]);
    }

    while(ind.size()) {
        order[n - ind.size()] = *ind.begin();
        ind.erase(ind.begin());
    }

    vector<int64_t> ret;
    int64_t inv = 0;
    for(timer = 1; timer <= 2; timer++) {
        for(int i = n - 1; i >= 0; i--) {
            int64_t qul = a2d.query(order[i], v[order[i]]);
            int64_t qur = a2d.query(n, v[order[i]]);
            int64_t qdl = a2d.query(order[i], n);

            a2d.update(order[i], v[order[i]]);

            inv += qdl + qur - 2 * qul;
            if(timer == 2) ret.push_back(inv);
        }
        if(timer == 1) a2d.init();
    }

    reverse(ret.begin(), ret.end());
    ret.pop_back();
    for(auto e : ret) cout << e << " ";

    return 0;
}

