#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int N_MAX = 100000;

int N;
int P[N_MAX + 2];
int pos[N_MAX + 2];

int Q[N_MAX + 2];

vector <int> vy[N_MAX + 2];
void simUpdate (int x, int y) {
    for (int i = x; i <= N; i += i & -i) {
        vy[i].push_back(y);
    }
}
vector <int> Fen[N_MAX + 2];
void compress () {
    for (int i = 1; i <= N; i++) {
        sort(vy[i].begin(), vy[i].end());
        vy[i].resize(unique(vy[i].begin(), vy[i].end()) - vy[i].begin());
        Fen[i].resize((int) vy[i].size() + 1);
    }
}
int f (int i, int y) {
    int l = -1, r = (int) vy[i].size() - 1;
    while (l < r) {
        int mid = (l + r + 1) / 2;
        if (vy[i][mid] <= y) {
            l = mid;
        } else {
            r = mid - 1;
        }
    }
    return l + 1;
}
void update (int x, int y, int val) {
    for (int i = x; i <= N; i += i & -i) {
        for (int j = f(i, y); j <= (int) vy[i].size(); j += j & -j) {
            Fen[i][j] += val;
        }
    }
}
int query (int x, int y) {
    int sum = 0;
    for (int i = x; i >= 1; i -= i & -i) {
        for (int j = f(i, y); j >= 1; j -= j & -j) {
            sum += Fen[i][j];
        }
    }
    return sum;
}

ll answer[N_MAX + 2];

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> N;
    for (int i = 1; i <= N; i++) {
        cin >> P[i];
        pos[P[i]] = i;
        simUpdate(i, P[i]);
    }
    compress();
    for (int i = 1; i <= N - 2; i++) {
        cin >> Q[i];
    }
    ll total = 0;
    for (int i = 1; i <= N; i++) {
        total += query(i, N) - query(i, P[i]);
        update(i, P[i], +1);
    }
    answer[0] = total;
    for (int i = 1; i <= N - 2; i++) {
        int j = pos[Q[i]];
        update(j, P[j], -1);
        total -= query(j, N) - query(j, P[j]);
        total -= query(N, P[j]) - query(j, P[j]);
        answer[i] = total;
    }
    for (int i = 0; i <= N - 2; i++) {
        cout << answer[i] << " ";
    }
    cout << "\n";

    return 0;
}
