#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int N_MAX = 100000;

const int BUFFER_SIZE = 40000;
char buffer[BUFFER_SIZE];
int bpos = BUFFER_SIZE - 1;

char read_char () {
    if (++bpos == BUFFER_SIZE) {
        fread(buffer, sizeof(char), BUFFER_SIZE, stdin);
        bpos = 0;
    }
    return buffer[bpos];
}
int read_int () {
    int val = 0;
    char c;
    while (isdigit(c = read_char()) == true) {
        val = val * 10 + c - '0';
    }
    return val;
}

int N;
int P[N_MAX + 2];
int pos[N_MAX + 2];

int Q[N_MAX + 2];

vector <int> vy[N_MAX + 2];
void simUpdate (int x, int y) {
    for (int i = x; i <= N; i += i & -i) {
        vy[i].push_back(y);
    }
}
vector <int> Fen2D[N_MAX + 2];
void compress () {
    for (int i = 1; i <= N; i++) {
        sort(vy[i].begin(), vy[i].end());
        vy[i].resize(unique(vy[i].begin(), vy[i].end()) - vy[i].begin());
        Fen2D[i].resize((int) vy[i].size() + 1);
    }
}
int f (int i, int y) {
    int l = -1, r = (int) vy[i].size() - 1;
    while (l < r) {
        int mid = (l + r + 1) / 2;
        if (vy[i][mid] <= y) {
            l = mid;
        } else {
            r = mid - 1;
        }
    }
    return l + 1;
}
void update (int x, int y, int val) {
    for (int i = x; i <= N; i += i & -i) {
        for (int j = f(i, y); j <= (int) vy[i].size(); j += j & -j) {
            Fen2D[i][j] += val;
        }
    }
}
int query (int x, int y) {
    int sum = 0;
    for (int i = x; i >= 1; i -= i & -i) {
        for (int j = f(i, y); j >= 1; j -= j & -j) {
            sum += Fen2D[i][j];
        }
    }
    return sum;
}

ll answer[N_MAX + 2];

int Fen1[N_MAX + 2], Fen2[N_MAX + 2];
void update1D (int Fen[], int x, int val) {
    for (int i = x; i <= N; i += i & -i) {
        Fen[i] += val;
    }
}
int query1D (int Fen[], int x) {
    int sum = 0;
    for (int i = x; i >= 1; i -= i & -i) {
        sum += Fen[i];
    }
    return sum;
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    N = read_int();
    for (int i = 1; i <= N; i++) {
        P[i] = read_int();
        pos[P[i]] = i;
        simUpdate(i, P[i]);
    }
    compress();
    for (int i = 1; i <= N - 2; i++) {
        Q[i] = read_int();
    }
    ll total = 0;
    for (int i = 1; i <= N; i++) {
        total += query1D(Fen1, i) - query(i, P[i]);
        update(i, P[i], +1);
        update1D(Fen1, i, +1);
        update1D(Fen2, P[i], +1);
    }
    answer[0] = total;
    for (int i = 1; i <= N - 2; i++) {
        int j = pos[Q[i]];
        update(j, P[j], -1);
        update1D(Fen1, j, -1);
        update1D(Fen2, P[j], -1);
        total -= query1D(Fen1, j) + query1D(Fen2, P[j]);
        total += query(j, P[j]) * 2;
        answer[i] = total;
    }
    for (int i = 0; i <= N - 2; i++) {
        cout << answer[i] << " ";
    }
    cout << "\n";

    return 0;
}
