#include <bits/stdc++.h>
using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;

using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, 
                         tree_order_statistics_node_update>;

const int mxN = 1e5 + 7;
const int SZ = exp2(ceil(log2(mxN)));

ordered_set seg[2 * SZ];

void update(int val, int pos, int ind = 1, int l = 1, int r = SZ) {
    if (seg[ind].find(val) != seg[ind].end()) {
        seg[ind].erase(val);
    }
    else {
        seg[ind].insert(val);
    }
    
    if (l == r) {
        return;
    }
    
    int mid = (l + r) / 2;
    if (pos <= mid) {
        update(val, pos, 2 * ind, l, mid);
    }
    else {
        update(val, pos, 2 * ind + 1, mid + 1, r);
    }
}

int query(int val, bool type, int a, int b, int ind = 1, int l = 1, int r = SZ) {
    if (l > b || r < a) {
        return 0;
    }

    if (a <= l && r <= b) {
        if (type) {
            return seg[ind].size() - seg[ind].order_of_key(val) - 
                   (seg[ind].find(val) != seg[ind].end());
        }
        else {
            return seg[ind].order_of_key(val);
        } 
    }

    int mid = (l + r) / 2;
    return query(val, type, a, b, 2 * ind, l, mid) +
           query(val, type, a, b, 2 * ind + 1, mid + 1, r);
}

int arr[mxN], pos[mxN];

int32_t main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	
    int n;
    cin >> n;
    
    for (int i = 1; i <= n; ++i) {
        cin >> arr[i];
        
        update(arr[i], i);
        pos[arr[i]] = i;
    }
    
    int res = 0;
    for (int i = 1; i <= n; ++i) {
        res += query(arr[i], 0, i + 1, n);
    }
    
    cout << res << " ";
    for (int i = 0; i < n - 2; ++i) {
        int x;
        cin >> x;
        
        res -= query(x, 0, pos[x] + 1, n);
        res -= query(x, 1, 0, pos[x]);
        update(x, pos[x]);

        cout << res << " ";
    }
    cout << "\n";
}
